'use strict';

const {parentPort, workerData} = require('worker_threads');

function calculatePip(contour, x, y, contourStart, contourFinish) {
    let currentP = contour[contourStart];
    let u1 = currentP[0] - x;
    let v1 = currentP[1] - y;
    let f = 0;
    let k = 0;
    for (let ii = contourStart; ii < contourFinish; ii++) {
        const nextP = contour[ii + 1];

        const v2 = nextP[1] - y;

        if ((v1 < 0 && v2 < 0) || (v1 > 0 && v2 > 0)) {
            currentP = nextP;
            v1 = v2;
            u1 = currentP[0] - x;
            continue
        }

        const u2 = nextP[0] - x;

        if (v2 > 0 && v1 <= 0) {
            f = (u1 * v2) - (u2 * v1);
            if (f > 0) k = k + 1;
            else if (f === 0) return 0
        } else if (v1 > 0 && v2 <= 0) {
            f = (u1 * v2) - (u2 * v1);
            if (f < 0) k = k + 1;
            else if (f === 0) return 0
        } else if (v2 === 0 && v1 < 0) {
            f = (u1 * v2) - (u2 * v1);
            if (f === 0) return 0
        } else if (v1 === 0 && v2 < 0) {
            f = u1 * v2 - u2 * v1;
            if (f === 0) return 0
        } else if (v1 === 0 && v2 === 0) {
            if (u2 <= 0 && u1 >= 0) {
                return 0
            } else if (u1 <= 0 && u2 >= 0) {
                return 0
            }
        }
        currentP = nextP;
        v1 = v2;
        u1 = u2;
    }
    return k
}

const kScore = calculatePip(workerData.contour, workerData.x, workerData.y, workerData.contourStart,  workerData.contourFinish);
parentPort.postMessage(kScore);
